program login;

{$mode objfpc}

uses
  browserapp, JS, Classes, SysUtils, web, Webwidget, htmlwidgets;

type

  { TMyApplication }

  TMyApplication = class(TBrowserApplication)
    edtEmail: TTextInputWidget;
    edtPassword : TTextInputWidget;
    btnLogin : TButtonWidget;
    procedure doRun; override;
  private
    procedure BindElements;
    procedure doLoginClick(sender : TObject; event : TJSEvent);
    procedure doServerLogin(const aUser, aPassword: String);
  end;

procedure TMyApplication.BindElements;
begin
  edtEmail:=TTextInputWidget.Create(Self);
  edtEmail.elementID:='edtEmail';
  edtEmail.Refresh;
  edtPassword:=TTextInputWidget.Create(Self);
  edtPassword.ElementID:='edtPassword';
  edtPassword.Refresh;
  btnLogin:=TButtonWidget.Create(Self);
  btnLogin.ElementID:='btnLogin';
  btnLogin.Text:='Login <i class="fa fa-sign-in" aria-hidden="true"></i>';
  btnLogin.TextMode:=tmHTML;
  btnLogin.Refresh;
end;

procedure TMyApplication.doLoginClick(sender : TObject; event : TJSEvent);

begin
  DoServerLogin(edtEmail.Value,edtPassword.Value)
end;

procedure TMyApplication.doServerLogin(const aUser,aPassword: String);
begin
  window.alert('Logging in with user: '+aUser);
  // to be implemented.
end;

procedure TMyApplication.doRun;

begin
  BindElements;
  btnLogin.OnClick:=@DoLoginClick;
  Terminate;
end;

var
  Application : TMyApplication;

begin
  Application:=TMyApplication.Create(nil);
  Application.Initialize;
  Application.Run;
end.
